#++--++
#--++--
define easy_type::profile::firewall(
  String[1] $calling_class,
) {
  $ports          = lookup("${calling_class}::ports", Hash)
  $manage_service = lookup("${calling_class}::manage_service", Boolean)

  case  $::operatingsystem {
    'RedHat', 'CentOS', 'OracleLinux': {
      case ($::os['release']['major']) {
        '4','5','6': {
          easy_type::profile::firewall::iptables{ $calling_class:
            ports          => $ports,
            manage_service => $manage_service,
          }
        }
        '7', '8': {
          easy_type::profile::firewall::firewalld{ $calling_class:
            ports          => $ports,
            manage_service => $manage_service,
          }
        }
        default: { fail 'unsupported OS version when checking firewall service'}
      }
    }
    'Solaris':{
      warning 'No firewall rules added on Solaris.'
    }
    default: {
        fail "${::operatingsystem} is not supported."
    }
  }
}
